/**
 * P4
 * http://snarfed.org/space/p4
 *
 * Copyright 2001-2004
 * Ken Ashcraft <kashcraft+p4@gmail.com>
 * Ryan Barrett <p4@ryanb.org>
 * Maulik Shah <p4@maulik.net>
 * Nathan Stoll <nathanstoll+p4@gmail.com>
 *
 * File: client.cpp
 *
 * The mock backend client.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "p4plugin.h"
#include "p4client.h"
#include "p4mockclient.h"

#include <string.h>
#include <assert.h>
#include <iostream>
using namespace std;

const ushort ksyncer_plugin_id = 2481;

/** send_msg
 *
 * Reads lines from the user and sends them through the P4 backend. If the
 * connection is closed, send_msgs returns.
 */
void send_msgs()
{
  char msg[256] = "";

  cout << "Enter messages to be sent to the server, or a period on a blank ";
  cout << "line to disconnect." << endl;

  while (strcmp(msg, ".")) {
    cin >> msg;
    msg[255] = '\0';

    // strlen(msg) + 1 for null terminator
    p4_send(ksyncer_plugin_id, NULL, msg, strlen(msg) + 1, false);
  }
}


int main(int argc, char **argv)
{
  char addr[256];
  ushort port;

  cout << "Enter the hostname or IP address: ";
  cin >> addr;
  addr[255] = '\0';

  cout << "Enter the port (1025-65535): ";
  cin >> port;
  assert(port > 1024);

  p4_mock_setup(addr, port);
  p4_bootstrap();

  send_msgs();

  p4_quit();
  return 0;
}


